from statistics import stdev
import sqlite3
import os
import subprocess
import threading
from datetime import datetime

# Configuration
DOWNLOAD_DIR = os.path.expanduser("out")
OUTPUT_FORMAT = "[%i]%s"  # Default format for folder naming
COOKIE = "session-affinity=1742247176.302.46.898572|2968378f2272707dac237fc5e1f12aaf; csrftoken=UPArZ6krsCd44PZK5zut7f8tQfb7HqVH; sessionid=qszf9bsjr5kxlm9t9avhx8ivogoa4q44"  # For bypassing Cloudflare captcha
USER_AGENT = "Mozilla/5.0 (X11; Linux x86_64; rv:136.0) Gecko/20100101 Firefox/136.0"  # For bypassing Cloudflare captcha
HTML_VIEWER = False  # Generate HTML viewer
GENERATE_CBZ = True  # Generate Comic Book Archive
GENERATE_PDF = False  # Generate PDF file
THREAD_COUNT = 1  # Thread count for downloading
TIMEOUT = 30  # Timeout in seconds
RETRY_COUNT = 3  # Retry times when download fails

# Database setup
def init_database():
    conn = sqlite3.connect('nhentai_downloads.db')
    cursor = conn.cursor()

    # Create downloads table if it doesn't exist
    cursor.execute('''
    CREATE TABLE IF NOT EXISTS downloads (
        id INTEGER PRIMARY KEY,
        nhentai_id TEXT NOT NULL,
        status TEXT NOT NULL,
        message TEXT,
        added_time TIMESTAMP NOT NULL,
        updated_time TIMESTAMP NOT NULL
    )
    ''')

    conn.commit()
    conn.close()

def db_add_download(nhentai_id):
    conn = sqlite3.connect('nhentai_downloads.db')
    cursor = conn.cursor()

    now = datetime.now().isoformat()
    cursor.execute(
        "INSERT INTO downloads (nhentai_id, status, added_time, updated_time) VALUES (?, ?, ?, ?)",
        (nhentai_id, "pending", now, now)
    )

    conn.commit()
    conn.close()

def db_update_download_status(nhentai_id, status, message=None):
    conn = sqlite3.connect('nhentai_downloads.db')
    cursor = conn.cursor()

    now = datetime.now().isoformat()
    cursor.execute(
        "UPDATE downloads SET status = ?, message = ?, updated_time = ? WHERE nhentai_id = ?",
        (status, message, now, nhentai_id)
    )

    conn.commit()
    conn.close()

def db_get_all_downloads():
    conn = sqlite3.connect('nhentai_downloads.db')
    conn.row_factory = sqlite3.Row  # This enables column access by name
    cursor = conn.cursor()

    cursor.execute("SELECT * FROM downloads ORDER BY added_time DESC")
    downloads = [dict(row) for row in cursor.fetchall()]

    conn.close()
    return downloads

def db_get_download_status(nhentai_id):
    conn = sqlite3.connect('nhentai_downloads.db')
    conn.row_factory = sqlite3.Row
    cursor = conn.cursor()

    cursor.execute("SELECT status, message FROM downloads WHERE nhentai_id = ?", (nhentai_id,))
    result = cursor.fetchone()
    conn.close()

    if result:
        return {'status': result['status'], 'message': result['message']}
    return None

def download_doujinshi(nhentai_id, on_status_change=None):
    """
    Download a doujinshi using nhentai CLI.

    Args:
        nhentai_id: The ID to download
        on_status_change: Optional callback for status updates
    """
    # Update status in the database
    db_update_download_status(nhentai_id, "downloading")
    if on_status_change:
        on_status_change(nhentai_id, "downloading")

    try:
        # Try to check if nhentai CLI is installed
        try:
            subprocess.run(["nhentai", "--help"], stdout=subprocess.PIPE, stderr=subprocess.PIPE, check=True)
        except (subprocess.SubprocessError, FileNotFoundError):
            error_msg = "nhentai CLI tool is not installed"
            db_update_download_status(nhentai_id, "error", error_msg)
            if on_status_change:
                on_status_change(nhentai_id, "error", error_msg)
            return

        # Create download directory if it doesn't exist
        os.makedirs(DOWNLOAD_DIR, exist_ok=True)

        # Build command with all options
        cmd = ["nhentai"]

        # Add the ID
        cmd.extend(["--id", str(nhentai_id)])

        # Add explicit download flag to make sure it downloads
        cmd.append("--download")

        # Add output directory
        cmd.extend(["--output", DOWNLOAD_DIR])

        # Cleanup
        cmd.extend(["--move-to-folder"])

        # Add format option
        cmd.extend(["--format", f"'{OUTPUT_FORMAT}'"])

        # Add thread count
        if THREAD_COUNT > 0:
            cmd.extend(["--threads", str(THREAD_COUNT)])

        # Add timeout
        if TIMEOUT > 0:
            cmd.extend(["--timeout", str(TIMEOUT)])

        # Add retry count
        if RETRY_COUNT > 0:
            cmd.extend(["--retry", str(RETRY_COUNT)])

        # Add exit-on-fail option to prevent incomplete downloads
        cmd.append("--exit-on-fail")

        # Add HTML viewer option
        if HTML_VIEWER:
            cmd.append("--html")
        else:
            cmd.append("--no-html")

        # Generate CBZ if selected
        if GENERATE_CBZ:
            cmd.append("--cbz")

        # Generate PDF if selected
        if GENERATE_PDF:
            cmd.append("--pdf")

        # Add cookie if provided
        if COOKIE:
            subprocess.run(["nhentai", f"--cookie=\"{COOKIE}\""],
                stdout=subprocess.PIPE,
                stderr=subprocess.PIPE)
            print("Set nhentai cookie")

        # Add user agent if provided
        if USER_AGENT:
            subprocess.run(["nhentai", f"--useragent=\"{USER_AGENT}\""],
                stdout=subprocess.PIPE,
                stderr=subprocess.PIPE)
            print("Set nhentai user agent")

        # For debugging: print the command (excluding sensitive info)
        debug_cmd = list(cmd)

        print(f"Executing: {' '.join(debug_cmd)}")
        print(f"Working directory: {os.getcwd()}")
        print(f"Download directory: {DOWNLOAD_DIR}")

        process = subprocess.Popen(
            cmd,
            stdout=subprocess.PIPE,
            stderr=subprocess.PIPE,
            text=True
        )
        stdout, stderr = process.communicate()
        print(f"Full STDOUT: {stdout}")
        if (stderr):
            print(f"Full STDERR: {stderr}")

        if process.returncode == 0:
            # Success
            db_update_download_status(nhentai_id, "success", "Download completed")
            if on_status_change:
                on_status_change(nhentai_id, "success", "Download completed")
            print(f"Download successful for ID {nhentai_id}")

        else:
            # Error
            error_msg = f'Download failed: {stderr}'
            db_update_download_status(nhentai_id, "error", error_msg)
            if on_status_change:
                on_status_change(nhentai_id, "error", error_msg)
            print(f"Download failed for ID {nhentai_id}")
            print(f"STDERR: {stderr}")
    except Exception as e:
        # Error handling
        error_msg = f'Error: {str(e)}'
        db_update_download_status(nhentai_id, "error", error_msg)
        if on_status_change:
            on_status_change(nhentai_id, "error", error_msg)
        print(f"Exception during download for ID {nhentai_id}: {str(e)}")

def start_download_thread(nhentai_id, on_status_change=None):
    """Starts a download in a background thread"""
    threading.Thread(
        target=download_doujinshi,
        args=(nhentai_id, on_status_change),
        daemon=True
    ).start()

def get_settings():
    """Return current settings as a dict"""
    return {
        "download_dir": DOWNLOAD_DIR,
        "output_format": OUTPUT_FORMAT,
        "cookie": COOKIE,
        "user_agent": USER_AGENT,
        "html_viewer": HTML_VIEWER,
        "generate_cbz": GENERATE_CBZ,
        "generate_pdf": GENERATE_PDF,
        "thread_count": THREAD_COUNT,
        "timeout": TIMEOUT,
        "retry_count": RETRY_COUNT
    }

def update_settings(settings):
    """Update global settings from a dict"""
    global DOWNLOAD_DIR, OUTPUT_FORMAT, COOKIE, USER_AGENT, HTML_VIEWER
    global GENERATE_CBZ, GENERATE_PDF, THREAD_COUNT, TIMEOUT, RETRY_COUNT

    DOWNLOAD_DIR = settings.get("download_dir", DOWNLOAD_DIR)
    OUTPUT_FORMAT = settings.get("output_format", OUTPUT_FORMAT)
    COOKIE = settings.get("cookie", COOKIE)
    USER_AGENT = settings.get("user_agent", USER_AGENT)
    HTML_VIEWER = settings.get("html_viewer", HTML_VIEWER)
    GENERATE_CBZ = settings.get("generate_cbz", GENERATE_CBZ)
    GENERATE_PDF = settings.get("generate_pdf", GENERATE_PDF)
    THREAD_COUNT = settings.get("thread_count", THREAD_COUNT)
    TIMEOUT = settings.get("timeout", TIMEOUT)
    RETRY_COUNT = settings.get("retry_count", RETRY_COUNT)

# Initialize database when module is imported
init_database()
